#!/usr/bin/env python

# adds the pyvhist package to python's path. If you copy the
# examples to another directory, make sure that the pyvhist
# package is still in your path
import makepyvhistaccessible

from pyvhist import vhistblock, vhistfile
import os, sys


def relativeToScript(path):
    scriptDir = os.path.realpath(os.path.dirname(sys.argv[0]))
    return os.path.join(scriptDir, path)


with vhistblock.VhistBlock("06-morefiles.vhist", title="more files") as vb:
    f1 = vhistfile.InFile(relativeToScript("data/infile.txt"))
    f1.description = "A text file with important information"
    
    f2 = vhistfile.OutFile(relativeToScript("data/outfile.txt"))
    f2.embed = False
    
    vb.section.files.extend([f1, f2])

