#!/usr/bin/env python

# adds the pyvhist package to python's path. If you copy the
# examples to another directory, make sure that the pyvhist
# package is still in your path
import makepyvhistaccessible

from pyvhist import vhistblock, userattrs


v = userattrs.UserValue

P = userattrs.UserAttributes()
P.numIterations = 123
P.pixelSize = v(22, unit="mm")
P.stepSizes = v([5, 2.5, 1.25], formatStr="%0.3f")


with vhistblock.VhistBlock("08-user-defined-attributes.vhist",
        title="more files") as vb:
    P.addToUserAttrs(vb.section, "params")
