#!/usr/bin/env python

# adds the pyvhist package to python's path. If you copy the
# examples to another directory, make sure that the pyvhist
# package is still in your path
import makepyvhistaccessible

from pyvhist import vhistblock, vhistfile, userattrs
import os, sys


def relativeToScript(path):
    scriptDir = os.path.realpath(os.path.dirname(sys.argv[0]))
    return os.path.join(scriptDir, path)


v = userattrs.UserValue

P = userattrs.UserAttributes()
P.size = v((2486, 1914), unit="pixels")
P.author = 'NASA\'s Mars Exploration Rover'
P.license = 'Public Domain'
P.source = 'http://marsrovers.jpl.nasa.gov/gallery/press/spirit/20050610a.html'


with vhistblock.VhistBlock("09-user-defined-attributes2.vhist",
        title="more files") as vb:
    f1 = vhistfile.InFile(relativeToScript("data/MarsSunset.jpg"))
    P.addToUserAttrs(f1, "params")
    vb.section.files.append(f1)

