#!/usr/bin/env python

# adds the pyvhist package to python's path. If you copy the
# examples to another directory, make sure that the pyvhist
# package is still in your path
import makepyvhistaccessible

from pyvhist import vhistblock, preview, userattrs

from matplotlib import pyplot as plot

CONSTANTS = userattrs.UserAttributes()
CONSTANTS.scale = 0.3
CONSTANTS.exponent = 0.4

def makeFigure(xs, ys):
    fig = plot.figure()
    plot.plot(xs, ys)
    plot.xlabel("function arguments")
    plot.ylabel("function values")
    description = "A function plot"
    return preview.Preview(fig, description)


def doSomeWork(n):
    xs = range(n)
    ys = []
    print "x\tf(x)"
    for x in xs:
        y = (x ** CONSTANTS.exponent) * CONSTANTS.scale
        ys.append(y)
        print "%d\t%f" % (x, y)
    return makeFigure(xs, ys)


with vhistblock.VhistBlock("13-preview.vhist",
        title="Create a preview image") as vh:
    sec = vh.section
    CONSTANTS.addToUserAttrs(sec, "parameters")
    
    p = doSomeWork(1000)
    sec.previews.append(p)

