#!/usr/bin/env python

# adds the pyvhist package to python's path. If you copy the
# examples to another directory, make sure that the pyvhist
# package is still in your path
import makepyvhistaccessible

from pyvhist import vhistblock, preview
import os, sys


def relativeToScript(path):
    scriptDir = os.path.realpath(os.path.dirname(sys.argv[0]))
    return os.path.join(scriptDir, path)


with vhistblock.VhistBlock("14-preview2.vhist",
        title="Create a preview image") as vb:
    p = preview.Preview(relativeToScript("data/MarsSunset.jpg"),
            "Sunset on Mars")
    vb.section.previews.append(p)

