
from runprocess import runProcess
from utils import writeFile
import vhistfile

def saveGitInfo(gitWorkingCopyDir, vhistSection, tempDir):
    cwd = gitWorkingCopyDir
    (retval, revision) = runProcess("git rev-parse HEAD", cwd=cwd,
            mergeOutputs=True)
    (retStatus, status) = runProcess("git status", cwd=cwd, mergeOutputs=True)
    (retDiff, diff) = runProcess("git diff", cwd=cwd, mergeOutputs=True)
    
    statusFilename = tempDir.createTempFile("git-status.txt")
    writeFile(statusFilename, status)

    diffFilename = tempDir.createTempFile("git-diff.txt")
    writeFile(diffFilename, diff)
    
    vdiff = vhistfile.InFile(diffFilename, description="git diff output")
    vdiff.userAttrs["gitDiffReturnValue"] = retDiff
    
    vstatus = vhistfile.InFile(statusFilename, description="git status output")
    vstatus.userAttrs["gitStatusReturnValue"] = retStatus
    
    vhistSection.files.extend([vstatus, vdiff])
    vhistSection.userAttrs["gitRevision"] = revision.strip()

