

def limitedSetter(self, key, value):
    """
    Overriden version of __setattr__. This method prevents the creation of
    new class members if the "noNewMembers" member exists.
    
    """
    
    if not hasattr(self, key):
        if hasattr(self, "noNewMembers"):
            raise AttributeError, ("'%s' object has not attribute '%s' and "
                    "is not allowed to create it" % (self.__class__.__name__,
                    key))
    
    # attribute can be set, call the baseclasses setattr method
    baseclass = self.__class__.__base__
    baseclass.__setattr__(self, key, value)
