
import vhistfile

class Preview(object):
    def __init__(self, preview, description = None, basename = None,
            comment = None):
        self.preview = preview
        self.description = description
        self.basename = basename
        self.comment = comment
    
    def __saveToFile(self, filename):
        if self.basename != None:
            basename = basename
        else:
            basename = "preview.png"
    
    def toVhistFile(self, tempobj):
        basename = self.basename
        if self.basename == None:
            basename = "preview"
        
        if isinstance(self.preview, basestring):
            # handle filename
            pfile = vhistfile.VhistFile(self.preview, vhistfile.outfile(),
                    description=self.description, comment=self.comment)
            return pfile
        elif isFigure(self.preview):
            filename = tempobj.createTempFile(basename + ".png")
            self.preview.savefig(filename)
            pfile = vhistfile.VhistFile(filename, vhistfile.outfile(),
                    description=self.description, comment=self.comment)
            return pfile
        elif isNumpyArray(self.preview):
            filename = tempobj.createTempFile(basename + ".png")
            saveImage(filename, self.preview)
            pfile = vhistfile.VhistFile(filename, vhistfile.outfile(),
                    description=self.description, comment=self.comment)
            return pfile
        else:
            raise TypeError("unknown figure type: %s" % self.preview)

def saveImage(filename, array):
    import numpy
    if numpy.issubdtype(array.dtype, int):
        array = numpy.asarray(array, dtype=numpy.uint8)
    elif numpy.issubdtype(array.dtype, float):
        array = numpy.asarray(array * 255, dtype=numpy.uint8)
    
    import PIL.Image
    img = PIL.Image.fromarray(array)
    img.save(filename)

def isFigure(fig):
    return hasattr(fig, "savefig") and callable(fig.savefig)


def isNumpyArray(fig):
    try:
        import numpy
    except Exception as e:
        return False
    
    return isinstance(fig, numpy.ndarray)

