
import zipfile
import glob
import os
import sys

import vhistfile
import maketmp
import iomonitor
import utils

def unique(alist):
    return list(set(alist))


def zipSource(filename, tmpdir, srcdir, patterns, excludeDirs=None,
        excludePatterns=None):
    tmpFilename = tmpdir.createTempFile(filename)
    entries = utils.recursiveGlob(srcdir, patterns, excludeDirs,
            excludePatterns)
    entries = unique(entries)
    
    zfile = zipfile.ZipFile(tmpFilename, "w", zipfile.ZIP_DEFLATED)
    
    for entry in entries:
        zipEntry = os.path.join("sourcecode", entry)
        zfile.write(entry, zipEntry)
    zfile.close()
    vfile = vhistfile.VhistFile(tmpFilename, vhistfile.infile(),
            description="An archive containing the sourcecode of the python "
            "program used to perform this workflowstep", embed=True,
            compress=False)
    
    return vfile


def addSourceToSection(section, tmpdir, srcdir=None, patterns=["*.py"],
        excludeDirs=None, excludePatterns=None):
    if srcdir is None:
        srcdir = os.path.dirname(os.path.realpath(sys.argv[0]))
    vfile = iomonitor.dontRecordFileAccess(zipSource, "source.zip", tmpdir,
            srcdir, patterns, excludeDirs, excludePatterns)
    section.files.append(vfile)

